# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS$
#
package provide Gdhe::models 1.0

proc p3dArc { name r g b } {
    upvar \#0 ${name}NodeList nodeList
    if ![info exists nodeList] return
    
    object p3d${name}NodeList {
        upvar \#0 ${name}NodeList nodeList

        color $r $g $b
        eval "polyline [expr [llength $nodeList]/3] $nodeList"
    }
}

proc p3dResetArc { name } {
    upvar \#0 ${name}NodeList nodeList
    catch { unset nodeList }
}

proc p3dResetAll { } {
    global p3dArcNames

    if {![info exists p3dArcNames]} { return }
    foreach a $p3dArcNames {
	upvar \#0 $a arc
	catch { unset arc }
	catch "objectDelete p3d${a}NodeList"
    }

    catch { unset p3dArcNames }
}

proc p3dAddNode { name x y z } {
    upvar \#0 ${name}NodeList nodeList
    global p3dArcNames

    if ![info exists nodeList] {
        set nodeList "$x $y $z"
	lappend p3dArcNames $name
    } else {
	set nodeList "$nodeList $x $y $z"
    }

    catch "objectDelete p3d${name}NodeList"
}
